Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*

Bug #579300 reported by Daniel T Chen on 2010-05-12
210
This bug affects 37 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Wishlist
Unassigned

Bug Description

In Maverick we're investigating using OSSp to shunt all apps attempting to use the older, in-kernel OSS API to use pulse instead. To do so, we'll need to disable all forms of OSS (native and emulated). This means that we need to turn off the following kernel configuration options in ubuntu-maverick.git (current values given):

debian.master/config/config.common.ubuntu:3738:CONFIG_SND_MIXER_OSS=m
debian.master/config/config.common.ubuntu:3751:CONFIG_SND_OSSEMUL=y
debian.master/config/config.common.ubuntu:3757:CONFIG_SND_PCM_OSS=m
debian.master/config/config.common.ubuntu:3758:CONFIG_SND_PCM_OSS_PLUGINS=y
debian.master/config/config.common.ubuntu:3776:CONFIG_SND_SEQUENCER_OSS=y
debian.master/config/config.common.ubuntu:3886:CONFIG_SOUND_OSS=m
debian.master/config/config.common.ubuntu:3887:CONFIG_SOUND_OSS_CORE=y
debian.master/config/config.common.ubuntu:3888:CONFIG_SOUND_OSS_CORE_PRECLAIM=y

Daniel T Chen (crimsun) on 2010-05-12
description: updated
Changed in linux (Ubuntu):
importance: Undecided → Wishlist
Changed in linux (Ubuntu):
assignee: nobody → Leann Ogasawara (leannogasawara)
status: New → Triaged
status: Triaged → In Progress
Andy Whitcroft (apw) on 2010-05-17
Changed in linux (Ubuntu):
milestone: none → maverick-alpha-1
Changed in linux (Ubuntu):
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :
Download full text (3.1 KiB)

This bug was fixed in the package linux - 2.6.34-4.11

---------------
linux (2.6.34-4.11) maverick; urgency=low

  [ Amit Kucheria ]

  * SAUCE: omap: remove calls to usb_nop_xceiv_register from board files
  * [Config] Add support for OMAP-mainline flavour

  [ Andy Whitcroft ]

  * SAUCE: powerpc: fix compile error when ptrace.h is included from
    userspace
    - LP: #583733

  [ Chase Douglas ]

  * Revert "SAUCE: Don't register vga16fb framebuffer if other framebuffers
    are present"
  * Revert "SAUCE: Disable function tracing after hitting __schedule_bug"
  * Revert "SAUCE: drm/i915: don't change DRM configuration when releasing
    load detect pipe"

  [ Kees Cook ]

  * SAUCE: fs: block cross-uid sticky symlinks
  * SAUCE: fs: block hardlinks to non-accessible sources

  [ Koen Kooi ]

  * SAUCE: board-omap3-beagle: add DSS2 support

  [ Leann Ogasawara ]

  * Revert "staging/go7007 -- disable"
  * Revert "[Config] staging/winbond -- disable"
  * Revert "Disable 4MB page tables for Atom, work around errata AAE44"
  * Revert "SAUCE: sync before umount to reduce time taken by ext4 umount"
  * Revert "SAUCE: Enable an e1000e Intel Corporation 82567 Gigabit
    controller"
  * Revert "SAUCE: Fix MODULE_IMPORT/MODULE_EXPORT"
  * Revert "SAUCE: Created MODULE_EXPORT/MODULE_IMPORT macros"
  * Revert "SAUCE: input/mouse/alps: Do not call psmouse_reset() for alps"
  * Revert "SAUCE: r8169: disable TSO by default for RTL8111/8168B
    chipsets."
  * Revert "[Upstream] b43: Declare all possible firmware files."
  * Revert "add Breaks: against hardy lvm2"
  * Revert "SAUCE: Guest OS does not recognize a lun with non zero target
    id on Vmware ESX Server"
  * Revert "SAUCE: Catch nonsense keycodes and silently ignore"
  * [Config] Enable CONFIG_ECRYPT_FS=y for ports
  * [Config] Enable CONFIG_USB=y for armel and sparc
  * [Config] Enable CONFIG_SCSI=y for ia64 and sparc
  * [Config] Enable CONFIG_RFKILL=y for ports
  * [Config] Enable CONFIG_ATH9K_DEBUGFS=y
  * [Config] Enable CONFIG_IWMC3200TOP_DEBUGFS=y
  * [Config] Enable CONFIG_RCU_FAST_NO_HZ=y
  * [Config] Enable CONFIG_IWLWIFI_DEVICE_TRACING=y
  * [Config] Enable CONFIG_LIBERTAS_MESH=y
  * [Config] Enable CONFIG_MMC_RICOH_MMC=y
  * [Config] CONFIG_RT2800USB_UNKNOWN=y
  * [Config] Enable CONFIG_VGA_SWITCHEROO=y
  * [Config] Enable CONFIG_CEPH_FS=m
  * [Config] Enable CONFIG_CRYPTO_PCRYPT=m
  * [Config] Enable CONFIG_EEEPC_WMI=m
  * [Config] Enable CONFIG_RT2800PCI=m
  * [Config] Enable CONFIG_SCSI_HPSA=m
  * [Config] Enable CONFIG_VHOST_NET=m
  * [Config] Disable CONFIG_SND_HDA_INPUT_BEEP_MODE by default
    - LP: #582350
  * [Config] Disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS
    - LP: #579300
  * [Config] Enable CONFIG_PCIEASPM=y
    - LP: #333990
  * [Config] updateconfigs for OMAP flavour

  [ Loïc Minier ]

  * Enable perf tools on armel

  [ Tim Gardner ]

  * SAUCE: Updated ndiswrapper to 1.56
    - LP: #582555
  * [Config] Added virtual flavour
  * [Config] Remove support for sub-flavours
  * [Config] Removed amd64 preempt flavour
  * [Config] updateconfigs, updateportsconfigs after flavour munging
 -- Leann Ogasawara <email address hidden> Tue, 25 May 2010 09:34:5...

Read more...

Changed in linux (Ubuntu):
status: Fix Committed → Fix Released

This was not a Bug at all! The "fix" is a Bug!!
===================================

OSS Proxy is inappropriate as replacement for Alsa-OSS emulation.
The OSS Support has now simply been removed without the OSS proxy have been released as replacement. Lots of people dont understand why their TV or Radio volume-control got stuck suddenly!
Meanwhile I have build and tested OSS proxy here but it is crap.
As you can read here http://userweb.kernel.org/~tj/ossp/ :

"The mixer behaves a bit differently tho. In the original OSS,
/dev/mixer is the hardware mixer, so adjusting volumes there affects
all audio streams. When using ossp, each process group gets its own
mixer and the mixer always contains only two knobs - PCM and IGAIN.
Combined with per-stream volume control of pulseaudio, this scheme
works quite well for applications with embedded volume control
although it makes standalone OSS mixer programs virtually useless"

The tvtime binary needs /dev/mixer:line or /dev/mixer:cd but exactly that is not possible with OSS Proxy since it only supports PCM and IGAIN and that only for one soundcard. If one wants to use it for more soundcards, a smart wrapper mechanism have to be developed yet.

Please undo this changes!

OSSp is not ready yet for use. I know that OSS itself is deprecated but please don't remove good working emulation in order to replace it with nothing or crapy proxy mechanisms.

Download full text (3.7 KiB)

Hello Daniel T Chen.

For one thing I thank You very well As by letting remove the oss emu it finnally guided me to a serious general multimedia audio bug which went sometimes that far in freezing video applications as well. This problem started for me as from ubuntu 9.10 (and many many users are confronted with it)
Oh yes we still found some work arounds (many times very time consuming and complicated). Finnaly All those bugs and audio problems leaving A majority off users who uses modern audio cards and or Motherboards built in chipset like realtek 889A using hda audio without audio at all.

The real bug is just pulse audio . Pulse audio indeed supports only a very very limited basic audio devices. So is it intentional ? It is now in use for long time and nothing changed about this. The several different analog inputs like cd in extra line in hda frontpannel out are not supported. and not configurable. And then as well i even dont spoke about the external spdif digital audio in and so on ... Pulse audio does bug the general alsa working when using hda audio. Since even the most simple laptop is now equiped with hda audio I don't now what Your trying. I perfectly understand that it is a hell of a job and very time consuming what Your attempting now, But believe me as long pulse audio itself is not furhter developped in order to support our provides the ability tho configuring support for all audio cards, it's a waste of time.

Now slowly we are running up to the point that a lot of users just uninstall and purge first all basic linux audio alsa and pulse. Take basic alsa source compile it and run without sound server like pulse leaving system sounds unusable. But at least their multimedia applications are working then.
Now on maverick this is even not enough anymore but users will be forced to recompile their kernel. Well I don't think that this last is for all users. I even did not mention the users who just simply reverted to bloody windows due to this audio problem I agree not very smart but I can understand them. As ubuntu is particullary unstable now for multimedia applications.

So it would be very nice if.

You would actually make Your own kernel for You and other pulse audio maintainers for developping purposes or eventually provide an updated basic ubuntu kernel using libesd-als0 and esd sound server. So persons who need and have evoluated audio cards are able to use the audio like it is forseen.

Only force the implementation from pulse audio the day it is developped for use with all audio cards, or at least has a configuration option to set correct audio cards settings channel and stack's like we can do into alsa-base.conf
options snd-hda-intel model=asus-p5q for example (my case)
This option will unfortunatly be needed as the automatic polling of audio devices true bios does not give this needed info. It only will give info about chipset and audio codecs used but no info about channels used. This is the case for all hda audio cards who uses more then simply basic chanels mic and line.

Also An easy use complete mixer is anyway a requirement for Multimedia users. So yes We all use gnome-alsa-mixer now,
but pulse bugs in some c...

Read more...

Per Ångström (autark) wrote :

This broke package oss-compat, see bug #659024.

Daniel T Chen (crimsun) wrote :

oss-compat needs to be (re)blacklisted. The decision to purge OSS support from Ubuntu userspace was started way back in 2005, and this move in kernelspace simply follows that trajectory (not to mention Fedora made strides in this area several releases ago).

Per Ångström (autark) wrote :

As far as I can see, there is no mention of this change in the release notes. In my opinion this change should have been more widely announced.

Nikola Kotur (kotnik) wrote :

This is very wrong.

With this "fix" you just rendered the only game in GNU/Linux worth playing - Enemy Territory - not worth playing, since there is no sound any more.

Nikola Kotur (kotnik) wrote :

Great. OSSp doesn't even compile in 10.10. Good work. Thanks for making me go from Ubuntu.

Changed in linux (Ubuntu):
status: Fix Released → Fix Committed

Please Turn on again native and emulated oss into maverick kernel core. Pulse does not support the majority off HDA audio cards. does not support line in mic in cd in. Leaving the majority off multimedia users on ubuntu without or bad working audio. For those special cases where audio cards works with pulse oss (the minority). They just can blacklist the native oss and then use there pulse.

thenk's

Bowmore (bowmore) wrote :

The same goes for Natty, please turn it on again.

As long as there is no acceptable replacement for OSS functionalwise it must not be turned off. As OSSp is not yet an option please start by finalizing that one before you turn OSS off.

> In Maverick we're investigating using OSSp to shunt all apps
> attempting to use the older, in-kernel OSS API to use pulse
> instead.

This investigation apparently didn't come true which should have resulted in OSS being turned on again.

VPablo (villumar) wrote :

Is there any PPA with a kernel with OSS activated?

James Andrewartha (trs80) wrote :

An apt-file search reveals linux-image-2.6.32-305-ec2 is in maverick and has snd-pcm-oss.ko although I don't know if you can use it on normal hardware.

Hello VPablo,

I do have the latest stable kernel 2.6.35-22.34 from ubuntu maverick compiled for amd64 oss included and it does work. (the oss emu work's ) /devdsp present /dev:mixer present

If you wish I can send it to you. (Image and Headers)

if you give mail (you need cabability to receive 50 mb's mails)

VPablo (villumar) wrote :

Yes please, my mail is on my profile but is my profile's login and gmail.com. Thanks.

I think there is a limit of 10 or 15 megs of each mail, you could rar the package.

Heloo VPablo

It's already .deb package. try to append it here.

Just install it with sudo dpkg -i

An here the kernel headers also to install with sudo dpkg -i

VPablo (villumar) wrote :

Thank you very much, now gnomeradio works again. Now I must NOT make any kernel upgrade until anyone (you, for example) puts here a kernel customized.

By the way,I have installed the kernel and the headers with the new installer for Maverick, not by console.

Happy it work's for you as well.

If there is an next kernel upgrade, It's many times accompanied with some more heavy upgrades.
Indeed when you see such one, do not update.
start op with ubuntu's original kernel first . (by selecting the ubuntu's orig kernel during boot in grub boot menu).
then uninstall the custom kernel and headers. Perform upgrade. reboot like asked to finish update.

If you do not do that there is a change that you end up with boot failure. and message:

"udevadm trigger is not permitted while udev is unconfigured."

 i was not able to resolve that problem on last update and ended up having to reinstall maverick from scratch.

Bhupendra (bst-28) wrote :

I have the same problem the difference is I am using Ubuntu 10.10 i386.Can you please provide i386 deb as well for custom kernel and headers.I will be very thankful to you because in my Ubuntu installation /dev/mixer is not present due to which I can't listen to line-in audio and thus tvtime says it don't support mute and volume.If you think I should create a separate bug report for this, please let me know.Thanks.

Hello,

I don'y know yet how to croscompile. But will look up . How to. But even if I was I would not be able to test it unless I did installed it myself. And unfortunately I'm already running a couple of versions. And need my hd for data as well :-))

But it is quit simple to perform. And make your own kernel with instructions from this site

http://www.howtogeek.com/howto/ubuntu/how-to-customize-your-ubuntu-kernel/

there is just a small problem with instructions :

fakeroot make-kpkg –initrd –append-to-version=-custom kernel_image kernel_headers this instruction must be :

fakeroot make-kpkg --initrd --append-to-version=-custom kernel_image kernel_headers

note the -- at initrd and append instead off the one character long stripe.

bowens44 (bowens44) wrote :

Christophe,

I attempted to compile a custom kernel following the instructions at the link you provided. It compiled but I still didn't have /dev/mixer so I think that I did not enable everything I needed to enable. What exactly do I have to enable in the kernel to have /dev/mixer and /dev/dsp etc?

Your kernel worked perfectly but I would like to be able to do this.

thanks

see also: https://bugs.edge.launchpad.net/ubuntu/+bug/634211

This bug is one of the shamest ever !

what_if (jonathan-a-phelps) wrote :

This breaks support for many older programs which only support OSS (real OSS... with fopen() support )

Would anything be broken if these kernel options were compiled as modules then blacklisted? I could then enable by editing a blacklist file instead of --recompiling a new kernel--

My suggestion: compile the OSS support as modules, then blacklist by default.

Comments?

hello,

What_if,

 I already proposed that. But there is no negatif effect to have oss into the core. If it's there Your not forced to use it, at start up you can blacklist it if you want.

So since pulse does not do at all what must be done concerning oss emu. There is no way to interfere from many programs whitout the oss emu (using this you also have the full posibility's of your audio hda cards if you adapt the alsa-base.conf with model = XXX)

Al other stuf trough pulse if you get it to work, your losing also synchronisation between video and audio with tv pci device cards.
It's very proccesor consuming on top total usseless.

Hello bowsen, Sorry I can't help you there as i don't have i386. Now in the comming days I will not be at home for a week.

greetings christophe

Cedric (cedriczg) wrote :

Bug https://bugs.edge.launchpad.net/ubuntu/+bug/634211 also affects me.
Is there any way to get working older programs that require /dev/dsp?
Thanks.

Dan McCombs (overridex) wrote :

+1 to annoyance.

I realized this change when I went to a LAN party that was playing Unreal Tournament 99 and had no sound. I tried the alsa-oss package to wrap it, but sound had a noticeable delay not suitable for games. My concern is that this OSS proxy will raise the same problem whenever it is included.

At the very least allow kernel OSS emulation to be easily enabled or installed for users who need it without a kernel recompile, and make it prominent in the release notes. Many of us have discovered this the hard way.

Kernel emulation worked well, and OSS is still necessary for many old native Linux games that will not be updated further. Please don't break it without very good reason and a well tested replacement.

-Dan

Steve Church (creepy) wrote :

Huh. Welcome to Microsoft Linux. That's... interesting, but terribly inconvenient.

It turns out this OSS garbage is responsible for my (cx8801) TV tuner cards' being able to capture audio from analog cable. Now due to an unfortunate bit of misguided and premature (but well-intentioned, I'm sure) house cleaning in the kernel config, I can't record my shows on Spike TV, E, or Comedy Central.

I feel the way I felt when Microsoft replaced the menubar and toolbars in Office with the "ribbon." The ribbon is cumbersome, does more harm than good, and is an abomination of proper UI design. But Microsoft is committed to their goal of making their products completely unusable, and I have no say in the matter. Now, once again, I sit shaking my fists at The Man, this time in the form of Canonical; and as usual, I plan to be thoroughly ignored.

You're lucky I'm not typing in all caps.

You know what? Screw that. I WILL TYPE IN ALL CAPS! Take that, Daniel Chen, Leann Ogasawara, and Andy Whitcroft! Now if you'll excuse me, I'm off to compile my own bleeding kernel to fix what you broke.

Steve and everyone else affected by tv tuners using the deprecated OSS API,
please be aware that there are two unofficial resolutions in place:

1) Use pulseaudio's module-loopback.
2) If you use tvtime, there's a pulseaudio backend written by a community
member.

Keep in mind as well that this removal is necessary to clear out the audio
jungle. Yes, some people will always be hurt by the eliminated backward
compatibility, but the long tail cannot be allowed to prevent consolidation
(and, err, progress).

Steve Church (creepy) wrote :

Hey Mr. Chen,

Firstly, thanks for responding. It's nice not to be ignored. And thank you for your hard work. Open source software would not be worthwhile without the efforts of people such as yourself.

Now. Pulseaudio is not a solution. Pulseaudio blows goats. I've never had it installed and heard things playing through my speakers at the same time. Pulse installed = speakers silent. Pulse removed = speakers speaking = rainbows, unicorns, daisies, porn and beer. Now I'm not opposed to reinstalling pulseaudio if I come across a howto with fewer than 20 steps between apt-get and I hear noise. Suggestions?

My point is that the unofficial resolutions to which you refer are not mature enough yet to be considered worthy of production. Until they are, config_*_*OSS* should remain enabled.

Hell, there shouldn't even need to be a workaround in the first place! It's not as if the hardware I have is uncommon or outdated. It's certainly neither fringe nor obsolete. I have a pcHDTV HD5500 and a Pinnacle PCTV HD 800i. They're both less than 4 years old, and they're both common. Mythbuntu is an official Canonical project, right? Is it logical for the kernel on which Mythbuntu runs not to support hardware which might likely be found in a Mythbuntu box?

Maturity, maturity, maturity. It's an important concept. OSS is old and unmaintained, but it is mature. It is reliable. It works. New hardware is being sold that uses OSS. Pulse, on the other hand... well, Ctrl-F and search this page for "pulse." Don't consider only my opinion.

Truly, I can appreciate the need to, as you say, "clear out the audio jungle." But don't do it yet. You've been planning to do this for 5 years. What's the rush now?

Please. Wait until workarounds are easier / more user friendly, or at least better documented. Ubuntu's supposed to be Linux for your grandmother. I wouldn't want my grandmother dealing with configuring pulse in its current incarnation, though.

&lt;3,
Steve

Ole Laursen (olau) wrote :

1) Use pulseaudio's module-loopback.
2) If you use tvtime, there's a pulseaudio backend written by a community member.

Could you please elaborate on how this is supposed to work for maverick?

I'm surprised why this hasn't been fixed yet when a solution has been known for several months.

Hello,

Sorry to say but tvtime gnome radio most of pci tv cards are just NOT working with pulse audio. Oh you can use sox and that stuff, But like said before it is very processor consuming, Causes delays (even with best possible settings ) between image and sound. If at the same time you perform large copy's of files in the background, Yes just that moment you watch tv since you have to wait anyway. But it's just a disaster seeing the images before the sound, on top of it sounds becomes garbled sometimes.

Again most HDA cards (chipsets) are NOT supported correctly by pulse audio !!!!! (sometimes not at all)

Whitout the oss emu into the kernel core Maverick is a complete garbage multimedia wise. Note that many older computer games as well DO not work without oss emu. And newer games ??? well for linux not to much choice i think.

SO PLEASE ENABLE OSS EMU INTO THE KERNEL AS STANDARD It will be needed for many many years as long pulse is so bad.

Maverick is good for much things, But Mister T Cheng Enabling the oss emu does not degrade maverick at all and does NOT produce any other bug. It's not an accident that oss emu is just a standard feature into linux basic kernels. It's just needed.

Now maverick is multimedia wise just like windows which bugs already into the package.

why is ALSA OSS emulation is so taboo here ?

It is not like OSS is here to create compatibility issues ...

Absolutely no programs use OSS by default ! Only programs that don't support ALSA at all are requesting this compatibility layer !

By disabling ALSA OSS emulation you don't make the life of anyone easier ! You just break the only programs/games that will not be modified to use ALSA instead. And break all V4L drivers !

If you plan to remove ALSA OSS emulation, remove all V4L from the kernel, remove all the programs that only use OSS on the repositories. And SAY GOOD BYE TOO ALL OF US !!!

I will not blame Pulseaudio like any other in this thread, I will just say one thing. GNU/Linux as been a long time the place of choice, the choice to use what you want, if you want it. And I don't want that Ubuntu become Pulseaudio dependent !

And one other thing, Pulseaudio is easier than Alsa and his OSS emulation ? I don't think so !! Pulseaudio add an other piece of complexity in the linux audio jungle ! Why using it ? Why ? The peoples who want it can install it if they want ! Why is it in Ubuntu base ? For the most part of us it serve no purpose at all !!

I love Ubuntu ... I loved Ubuntu ... I think it's time to become serious and stop integrating beta materials in Ubuntu ...

PS: Sorry, some sentences can be strange or unreadable, English is not my natural language ...

Hello Fabien,

You're very right about it. But pulse is well needed. One of the important things from pulse is the function as sound server. On that point it's working very well. Also it's doeing a great job for playing music files and so on. Like rhytmbox.

But yes it is really needed to have oss emu enabled into the kernel since indeed almost all pci tv cards are not working wel whitout it.
Sound hda cards are not very good supported by pulse (even wrongly) all the cd in line in mic in do not work trough pulse.
But they do wel work trough alsa as long you untoggle manually via alsa-mixer and put the right setting for your card into
alsa-base.conf.

Then the games .... gnome radio ... and so on.

We can say

UBUNTU IS MULTIMEDIA WISE JUST CRAP WHITOUT THE OSS EMU ENABLED INTO THE CORE AND REALLY IS ON A GOOD WAY TO BEAT WINDOWS INTO THE BAD OPERATING SYSTEMS. ALSO THE WHOLE LINUX PURPOse AND UPSET IS FULLY GONE BY THAT UBUNTU IS GOING IN 180 ° OPOSSITE DIRECTION THEN THE GOAL OF LINUX.

Steve Church (creepy) wrote :

I just reinstalled pulseaudio last night. I immediately remembered why I had uninstalled it in the first place. padevchooser does not detect or let me choose iec958 5.1 channel output. My machine is connected to my audio receiver via either optical or digital coaxial line (I can't remember off the top of my head which, but it doesn't matter because neither would be supported by pulse) for DTS and Dolby / AC3 5.1 playback. So with pulse installed and active, I have no sound output.

Pulse is not a solution.

Daniel T Chen (crimsun) wrote :

@Ole I'm on a very slow Internet connection currently; it would take
less time for you to find the Launchpad bug affecting tvtime that
contains a link for a PPA containing the community member-developed
PulseAudio backend (https://bugs.launchpad.net/ubuntu/+source/tvtime).

@Christope @Fabien OSSv4.1 is available in universe as a DKMS-enabled
source if you truly need native OSS (not compatibility). You can even
configure PulseAudio to use this OSS backend.

@Steve padevchooser is deprecated. Is the IEC958 option not available
(named differently, probably) via
Sound Preferences (assuming you're using GNOME) in the Hardware tab?

I have tried OSS4 !

Does not solve the problem at all !!!

1. XawTV and V4L doesn't work with OSS4 (I don't know why, I think something is broken somewhere or an API change I don't know ...)

2. All Alsa Apps works like Crap with OSS4

3. Audacity don't work at all (OSS or ALSA mode)

There is no other solution ! Turn ON this ALSA OSS emulation ! It's not like it will hurt someone or something !

ALSA OSS is a compatibility layer, not a full set of driver like OSS4 or OSS3 (built in linux kernel and depreciated). It produce no conflict at all !

Is it not obvious that it is just stupid to remove OSS compatibility ? In the case that we don't use it, activating or deactivating OSS compatibility serve no purpose. In the case that you actually use it and no other solution exist to make what you want, you make Ubuntu painful to use to a lot of peoples around the world !

I speak for french community here, In our forum, we have a significant amount of people who are also horribly worried about the future of Ubuntu !

I will be totally honest with you ... If this issue is not closed with Ubuntu 11.04, I will consider to use another linux distribution ... And it hurts me inside. I have contributed a lot to many ways for many years to spread the word about Ubuntu, I have contributed on the translation, contributing to the Ubuntu-fr Wiki. I feel like raped ... Or like everything have no sense in this world ...

Steve Church (creepy) wrote :

@Daniel Chen,

Mythbuntu uses XFCE as the desktop environment. Do you happen to know the name of the command that launches whatever pulse configuration interface that isn't deprecated? There's nothing relevant in XFCE's menus, so I'll have to launch from the bash prompt. Thanks!

Daniel T Chen (crimsun) wrote :
Download full text (4.4 KiB)

> 1. XawTV and V4L doesn't work with OSS4 (I don't know why, I think
> something is broken somewhere or an API change I don't know ...)

In this case, bugs need to be filed against the relevant source
packages, and we need to assist upstream developers in fixing them.
Wouldn't you want the bugs fixed regardless where they lie? Honestly,
it sounds like XawTV and V4L are making poor assumptions about the
older OSS API (much like ALSA makes poor assumptions about the
underlying hardware - assumptions only exposed through the
introduction of PulseAudio).

> 2. All Alsa Apps works like Crap with OSS4

What compatibility layer, if any, are you using? Are you routing
everything ALSA through PulseAudio configured to use OSS? Are you
routing everything ALSA through OSS4's alsa-lib emulation? Are you
routing everything ALSA through PulseAudio configured to use ALSA
through OSS4's alsa-lib emulation?

> 3. Audacity don't work at all (OSS or ALSA mode)

See above (question 2)

> There is no other solution ! Turn ON this ALSA OSS emulation ! It's not
> like it will hurt someone or something !

There is at least one solution, which is to provide the affected
programs with native PulseAudio backends. Sooner than later OSS is
going to be dropped from upstream Linux utterly, and then Ubuntu won't
be carrying it at all. Many distributions, e.g., Fedora, have already
disabled OSS emulation support from ALSA (being it loading or entirely
like Ubuntu has). Ubuntu needs to help consolidate, not help
fragment, the audio landscape. As long as this emulation support
remains enabled, we will remain in a quagmire of applications
experiencing contention for the audio device, which increases the
friction for adoption of Free Software.

Yes, this is all easier said than done. But this is the way forward.

> ALSA OSS is a compatibility layer, not a full set of driver like OSS4 or
> OSS3 (built in linux kernel and depreciated). It produce no conflict at
> all !

...except that it *does* produce conflicts. If a program uses OSS
emulation, it *prevents* all other programs from accessing the sound
device concurrently. How can we expect a smooth user experience if
this is allowed to occur? (Yes, the same exists for ALSA plughw: and
plug:{everything else}.)

> Is it not obvious that it is just stupid to remove OSS compatibility ?
> In the case that we don't use it, activating or deactivating OSS
> compatibility serve no purpose. In the case that you actually use it and
> no other solution exist to make what you want, you make Ubuntu painful
> to use to a lot of peoples around the world !

Progress is always painful; some people's use cases will always be
underserved with the new configuration. This is unfortunate, but the
solution is to fix the programs to use the new configuration. See the
bit above about native PulseAudio backends.

> I speak for french community here, In our forum, we have a significant
> amount of people who are also horribly worried about the future of
> Ubuntu !

I don't think you speak for anyone but yourself (despite there being a
lot of angry users). I certainly don't speak for anyone but myself,
though I've been willing to assist i...

Read more...

Daniel T Chen (crimsun) wrote :

> Mythbuntu uses XFCE as the desktop environment.  Do you happen to know
> the name of the command that launches whatever pulse configuration
> interface that isn't deprecated?  There's nothing relevant in XFCE's
> menus, so I'll have to launch from the bash prompt.  Thanks!

Xfce doesn't have a native UI AFAICT, but you can install and use
pavucontrol from universe.

I don't have the same way of thinking.

For me, the idea is everithing need to work before dropping such feature ! Not dropping the feature and break all compatibility !

You have to understand me ! And every other persons who have a video capture device !

All this people have to go back to Lucid and keep using Lucid and wait for an hypothetical ALSA version of V4L and XawTV that will nether exist !

> OSS can "*prevents* all other programs from accessing the sound
device concurrently"

Yes, but no OSS prevent to use OSS programs ! And because virtually nothing use OSS by default, I think this "OS lock syndrome" is already for most of us a problem of the past !

I know your reason, I know what you are trying to do. But Is it not too early ? Or is it really a good idea ? I think this idea cause more trouble that it drop ...

And like you said, you are investigating at using OSSp why OSSp not here ? And if it come, will it allow V4l users to use their TV cards ? I don't think this will really work ... or at least work as great as it worked before ...

And if you think this decision was great, just look at all the "duplicate" bugs around ... The main problem is not dropping OSS but V4L and a lot of other applications that don't support OSS, yes I know ... but this work have to be done ! And he is not !

PS: let's forget about OSS4 that's not the solution and it 's too complicated to install for end user. Ubuntu is user friendly or not ?

Steve Church (creepy) wrote :

> > Mythbuntu uses XFCE as the desktop environment. Do you happen to know
> > the name of the command that launches whatever pulse configuration
> > interface that isn't deprecated? There's nothing relevant in XFCE's
> > menus, so I'll have to launch from the bash prompt. Thanks!
>
> Xfce doesn't have a native UI AFAICT, but you can install and use
> pavucontrol from universe.

Ya. pavucontrol what what I launched from within padevchooser last night when I was experimenting. My choices are around 20 different permutations of analog stereo, analog surround, and digital stereo input and output. No choice for digital surround is available. The only options for digital output are stereo or stereo duplex with either analog or digital input. lspci identifies my sound card as "nVidia Corporation MCP55 High Definition Audio," for what it's worth. ALSA plays 5.1 through the s/pdif outputs no problem. Pulse doesn't. Recommendations? Would JACK be worth investigating as an alternative to pulse?

Download full text (9.5 KiB)

Dear Mister Daniel T Chen

I can answer same way;

> In this case, bugs need to be filed against the relevant source
>packages, and we need to assist upstream developers in fixing them.
>Wouldn't you want the bugs fixed regardless where they lie? Honestly,
>it sounds like XawTV and V4L are making poor assumptions about the
>older OSS API (much like ALSA makes poor assumptions about the
>underlying hardware - assumptions only exposed through the
> introduction of PulseAudio).

Those packages do not seems to be under developpenment anymore. For some, mostly just older hardware devices persons unfortunately needs to keep on using them as long those devices are usable. You seem to forget that they are just mostly analog devices. In the future yes they will go away . But it will take another +- 5 years. So it absolutely does not harm to leave oss emu as long we need them.

> What compatibility layer, if any, are you using? Are you routing
>routing everything ALSA through OSS4's alsa-lib emulation? Are you
>routing everything ALSA through PulseAudio configured to use ALSA
>through OSS4's alsa-lib emulation?

Yes this is well a good point and question. So far as it concerns me The answer off course is now. It's evident that i always keep up with the most recent developpment as fare it does work how its ment to work. a good example is Vmware for workstation has long time used /dev/dsp but now they are also up and using alsa. It's evident that I use in this case Alsa an will not use the oss for vmware anymore. But Here You point is good Some persons need to be wake up that there is a better way for some things and off course must try as far it's possible and really working to go further with the developpement.
The oss from pulse self is unfortunately pure crap. And even very contraproductif. the good way is to direct interact with alsa self not trough the unfinished pulse. As long you need oss it should be trough the basic alsa oss emu.

>There is at least one solution, which is to provide the affected
>programs with native PulseAudio backends. Sooner than later OSS is
>going to be dropped from upstream Linux utterly, and then Ubuntu won't
>be carrying it at all. Many distributions, e.g., Fedora, have already
>disabled OSS emulation support from ALSA (being it loading or entirely
>like Ubuntu has). Ubuntu needs to help consolidate, not help
>fragment, the audio landscape. As long as this emulation support
>remains enabled, we will remain in a quagmire of applications
>experiencing contention for the audio device, which increases the
>friction for adoption of Free Software.

>Yes, this is all easier said than done. But this is the way forward.

I still have to try that out but it's very complicated . i'm also very occupied on other linux developemnts concerning dreambox and unfortunately still can't split myself in then. Far much easier to just recompile my own kernel with oss included since this at the end will work for all applications and not only for tvtime. Also this will not solve compatability from my sound chipset realtek 889a on gigabyte extreme mb. and pulse audio (for alsa self it's ok by just modifying the alsa_base.conf located into /etc/...

Read more...

Mike Thomas (rmthomas) wrote :
Download full text (5.0 KiB)

Dear Mr Chen,

I have been following this thread with interest from two distinct points of view:

- I am the author of an out-of-tree audio-video device driver which works fine under Ubuntu 10.04 LTS but is silent under Ubuntu 10.10, and I need to decide what to do about it:

http://sourceforge.net/projects/easycapdc60/develop

- I am also an ordinary Linux user who prefers things to Just Work, like everybody else.

I have no special expertise in Linux audio, and not much interest in it (the audio signal is merely a linear string of bytes - what's all the fuss about?). When I perform Google searches on the OSS/ALSA/PulseAudio wars I see a lot of vituperative anecdotes, but none of these really explain what's at stake, and I'm too lazy to trawl the specialist mailing lists of the past five years to find the tiny minority of postings that would throw light on strategy options for tackling technical issues. In my ignorance, then, I have the following simplistic view of the present situation:

- OSS is bad, because of licensing issues in the past but more importantly because it does not properly share the soundcard (and its settings) between userspace applications. Low latency though.

- ALSA is good, because it is politically correct and resolves the soundcard sharing issue. Latency might be a problem or might not.

- PulseAudio is popular with people who put together Linux distributions (not only Ubuntu), but it is unclear to me what problem in ALSA it is intended to solve.

If I decide that I need to add ALSA to my device driver, I'll do it. Maybe a little grumpily, but it's no big deal. To help me in making that decision, I'd appreciate your brief comments on the following.

(1) If, as is likely, the outline of the distinction between OSS, ALSA and PulseAudio that I've given above is wrong, can you give me some links to authoritative articles which would put me right? (Obviously I'm not interested in superficial differences like desktop bling.)

(2) My impression is that PulseAudio (and to a lesser extent ALSA) evolved as a response to the needs of audio "enthusiasts" - people regularly using multiple audio applications simultaneously and with high-specification, and possible multiple, soundcards. My question is: what proportion of the Linux userbase (or the Ubuntu userbase) are "enthusiasts" in this sense? It is useful to distinguish "enthusiasts" from "single-application" users, who want audio to work out the box for just one or maybe two applications, for example YouTube or some awesome game, and do not care much about audio mixing or ways of preserving audio settings. I myself am a "one-application" user as defined here, and I do not object to manually tweaking a few volume controls on the rare occasions when it is necessary. The question, then, amounts to: what percentage of the userbase are "one-application" users?

(3) You mention in an earlier post that the objection to allowing OSS emulation is that "it *prevents* all other programs from accessing the sound device concurrently". If I am a "one-application" user and I choose to accept this limitation of OSS emulation, should I not be allowed to do so?

(4) In the same p...

Read more...

Daniel T Chen (crimsun) wrote :
Download full text (7.3 KiB)

> - OSS is bad, because of licensing issues in the past but more
> importantly because it does not properly share the soundcard (and its
> settings) between userspace applications.  Low latency though.

I won't delve into overtly political thrusts regarding whether OSS or
ALSA is good, per se (the latter was created partly because of
politics, but that isn't relevant here). I will say that many
(userspace) audio developers find the OSS API simpler. In the Linux
world, however, momentum lies with ALSA due to its high-profile
maintenance. Both OSS and ALSA offer some virtualization of
(de)muxing streams such that "properly shar[ing] the soundcard"
appears fairly transparent to the end user with the caveat that *all*
the applications in use must be fully supported, well behaved
non-abusers of *one* API.

Low latency isn't inherent to OSS. Its API can still be abused, but
the fewer context switches do offer something.

> - ALSA is good, because it is politically correct and resolves the
> soundcard sharing issue.  Latency might be a problem or might not.

From an audio developer's perspective, ALSA offers far more knobs to
twiddle. This complexity is both alluring and devastating. A
relative dearth of maintained library documentation certainly doesn't
help. In fact, the most up-to-date (and arguably, best) documentation
is actually the PulseAudio creator's linked from
http://0pointer.de/blog/projects/guide-to-sound-apis.html.

Again, higher latency with ALSA is inherent in more context switches,
but given the restrictions of Linux (rather, kernelspace), it makes
sense to handle the complexities and modularization (e.g.,
alsa-plugins) in userspace.

> - PulseAudio is popular with people who put together Linux distributions
> (not only Ubuntu), but it is unclear to me what problem in ALSA it is
> intended to solve.

PulseAudio's prime driver is the modern Linux desktop. If
insufficiently clear, it has never meant to supplant ALSA (and surely
it cannot, as it relies on a driver backend of some sort). However,
manipulating alsa-lib configuration files is nightmarish for more
familiar developers and users and downright insane for uninformed
ones. It brings a level of desktop use ease that, when coupled with
well behaved drivers, makes audio nary a consideration. Yes, of
course one could use nc(1) and aplay(1)/arecord(1) to mimick its
functionality, but doing so would still require an application
restart.

Let's be clear: PA isn't meant to supplant JACK, either; the former
traditionally was targetted toward less expensive internal High
Definition Audio chipsets/codecs; the latter, professional-grade
external audio devices. The use cases for either tend to be distinct
and thus have differing requirements.

> (1) If, as is likely, the outline of the distinction between OSS, ALSA
> and PulseAudio that I've given above is wrong, can you give me some
> links to authoritative articles which would put me right?

I've attempted (perhaps poorly) to distinguish the major points;
Lennart's guide above is far more authoritative.

> (2) My impression is that PulseAudio (and to a lesser extent ALSA)
> evolved as a response to the needs of audio "enth...

Read more...

Claudiu Vlad (claudiu-vlad) wrote :

Dear Mr Chen,

I totally agree Ubuntu should move forward and programs should be fixed to use pulseaudio.

I tried to find the tvtime package with pulseaudio backend, that you mentioned above, but with no luck.

Can you please point such a tvtime PPA ?

Any plans to add OSSp in 11.04 ? And/Or a dkms package that will be able to add and compile the OSS ALSA emulation instead of recompiling the all kernel ?

Or OSSp by default and the dkms package for those who have some troubles whit OSSp ?

This can be a good progress and everybody should be API with that ?

Also we can install OSSp or the DKMs package only if an application depends on that ! I think that should be a good idea and a Huge progress that not break anything !

Claudiu Vlad (claudiu-vlad) wrote :

:)
The "everybody should be API with that" phrase was supposed to be a joke,
right ?

Jokes are welcome, anyway, as long as everybody is NOT APY with the sound
system breaking brought by Maverick

So, again, could we please patch tvtime to work with pulseaudio ? Daniel
Chen said earlier there is such a patched version, but I couldnt find it.

On Mon, Nov 1, 2010 at 10:30 AM, Fabien Lusseau <email address hidden>wrote:

> Any plans to add OSSp in 11.04 ? And/Or a dkms package that will be able
> to add and compile the OSS ALSA emulation instead of recompiling the all
> kernel ?
>
> Or OSSp by default and the dkms package for those who have some troubles
> whit OSSp ?
>
> This can be a good progress and everybody should be API with that ?
>
> Also we can install OSSp or the DKMs package only if an application
> depends on that ! I think that should be a good idea and a Huge progress
> that not break anything !
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Yeah that's a joke ... I think everybody knew it ! But what I said is really what I think. There can be less intrusive solution to progressively remove OSS. And not use brutal force against us users that just want our system just working !

Ole Laursen (olau) wrote :

I did a bit of digging. In Fedora, it appears they have a patch to add ALSA support to tvtime, it seems like it enables one to use the ALSA mixer interface instead of the OSS interface (discussion at bottom): https://bugzilla.redhat.com/show_bug.cgi?id=498167

Note that tvtime's use of OSS doesn't fall into the categori of hogging the soundcard, it's merely using the mixer interface to control volume.

Steve Church (creepy) wrote :

I get that OSS has been deprecated for quite some time. I get that deprecated features eventually disappear. I get that the only way developers will stop developing for OSS is for OSS no longer to exist; and likewise for hardware manufacturers' depending on OSS.

As an end user, I want my stuff to work, though. It's not my responsibility to sacrifice for the greater good. I'm not interested in policing the confusion in the spaghetti code of audio in Linux. I don't care about enforcing proper procedures in shaping the development of multimedia applications. That's not my role.

It's an intolerable situation. Mr. Chen has his motivations; I have mine. Unfortunately, the two are mutually exclusive.

So, like Christophe Van Reusel before me, I'm pursuing the only recourse left available. I'm henceforth giving up on Canonical's kernels. I compiled my own kernel with OSS modules re-enabled, and I will refuse upgrades until I no longer have analog cable television service.

For what it's worth, at first I tried Mr. Van Reusel's packaged kernel and headers. For some reason on my machine, dkms failed to compile the NVidia kernel stuff when I installed them. So I made my own. See http://ubuntuforums.org/showthread.php?t=1607546 for details. I have my .config attached there if anyone wants it.

OSS is NOT depreciated ! It an absurdity ! OSS3 is depreciated ! OSS4 is maintained and ALSA OSS emulation is not depreciated (no mention of that in the kernel documentation).

OSS is still used in a lot of Unix like, FreeBSD for exemple, and OSS API emulation is one of the most important part of the interoperability inside free software desktop solutions !

I know that pulseaudio can be an common intermediate between every sound API, but pulseaudio is not perfectly compatible with OSS API and it seems that OSS in pulseaudio is depreciated too ! We are in a dead end !

Like I said before, we have to work on OSSp integration or ALSA OSS emulation in a separate package, and before that append, we NEED alsa oss in the main kernel because it is the only way now to get it working ...

It don't know how to say that in english clearly but you are making things in disorder ... Or I don't know how to say that, but you need the replacement before dropping a good functioning (but not perfect) feature ...

Steve Church (creepy) wrote :

@Fabien Lusseau

See attached screenshot.

In this circumstance, "deprecated" is not my opinion. It is a development state. I should have specified "OSS, such as is included with the Linux kernel, is deprecated." Mea culpa.

No ! What you view here is OSS 3 ! Not the Alsa OSS emulation ! ALSA OSS is a part of ALSA not a part of OSS !

I said OSS3, OSS3 is "OSS, such as is included with the Linux kernel." And yes I agree, he is depreciated ! Plain and simple !

I totally agree with you ! And OSS 3 has never been in Ubuntu !

To sum it up see this new screen shot.

You can view that yes OSS is depreciated, but inside ALSA section there is OSS emulation, and nothing here to say "that it is depreciated or anything else"

But I totally agree that ALSA OSS emulation is not perfect, but we have nothing else in a perfectly working state, but this can change, and if this appends, we have to use this new compatibility layer ! OSSp if it works seems to be a good idea. But it is not in Ubuntu, and It seems that something is not working has good has the good old OSS emulation ... But at least it is not complete removal ...

VPablo (villumar) wrote :

For those who gnomeradio doesn't work with ALSA, try this.
I have make gnomeradio work with ALSA. On this page:
http://www.taringa.net/posts/linux/5777157/Sintonizadora-K-World-PCI-TV-PVR-TV-7134SE-en-Linux.html
there is a solution. Make this script, as "/usr/local/bin/audioradio2.sh" p.e.:
-----------------------------------------------------------
#!/bin/sh
sox -r 32000 -t alsa hw:2,0 -t alsa hw:0,0 &
mpid=$!
gnomeradio
kill $mpid
-----------------------------------------------------------
Changing "hw:2,0" for your TV Card (1,0; 3,0; etc...) and for me works.

I have upgraded to a 2.6.35-23-generic not customized and without /dev/dsp and gnomeradio works perfectly.

Please, test it and thanks to Christophe Van Reusel for compiling a customized kernel.

Claudiu Vlad (claudiu-vlad) wrote :

tvtime and gnomeradio are working - this means I have sound, but the mixer
volume is disabled, so I have to install gnome-alsa-mixer, which is BAD.

Lets hope somebody will fix tvtiem and gnomeradio to work with pulseaudio
instead alsa

On Tue, Nov 2, 2010 at 2:56 PM, VPablo <email address hidden> wrote:

> For those who gnomeradio doesn't work with ALSA, try this.
> I have make gnomeradio work with ALSA. On this page:
>
> http://www.taringa.net/posts/linux/5777157/Sintonizadora-K-World-PCI-TV-PVR-TV-7134SE-en-Linux.html
> there is a solution. Make this script, as "/usr/local/bin/audioradio2.sh"
> p.e.:
> -----------------------------------------------------------
> #!/bin/sh
> sox -r 32000 -t alsa hw:2,0 -t alsa hw:0,0 &
> mpid=$!
> gnomeradio
> kill $mpid
> -----------------------------------------------------------
> Changing "hw:2,0" for your TV Card (1,0; 3,0; etc...) and for me works.
>
> I have upgraded to a 2.6.35-23-generic not customized and without
> /dev/dsp and gnomeradio works perfectly.
>
> Please, test it and thanks to Christophe Van Reusel for compiling a
> customized kernel.
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Hello pablo,

for gnome radio it's maybe a solution. But even then it's to processor intensif. For tv card itself it's a pain in the ass since there is a delay between image and sound. Off course i do not route out the sound to /dev/dsp in tv time. the only control we used was the /dev/mixer emu to untoggle the specified alsa mixer channel and change volume. My tv time card is connected to CD in from motherboard. Some connect it to line in by absence from other inputs. Then we don't have delay between image and sound and are not using (spoiling) valuable processor time. Sound can also be untoggled using alsa mixer. Or even better gnome-alsamixer.

Another option off course is the use of loopback into pulse, But since pulse does not support my sound card how it should be and there is no way to solve that. I do it straight trough alsa. On top of it you can't mixed several loopback inputs togheter with pulse Yes Pulse is very very far from complete.

Note: most new software use direct input into alsa . Tvtime and gnome radio are not under developpemnt anymore. For tv time there is a patch made to use direct hw:0:Line or CD instead of passing trough /dev/mixer . But I still did not found this patched version compiled for amd64 or the latest modified source to compile this myself. It seems to be called tvtime version 1.0.2-8sr... in ubuntu there is still version 1.0.2-6.

gr christophe

here just attached copy of pulse setup for loopback located into /etc/pulse

note the load-module module-loopback at the end of the file.

xpatch (jestersi) wrote :

+sigh+ Please put it back in. You don't have to enable the module by default.
I need to use the dtmfdial package right now to sort out a bug in a system.
I just updated and now I can't use the package because there is no /dev/dsp

Going to use virtualbox, install 10.04 get the dtmfdial package and go that way... but what a pain.

yota (yota-opensystems) wrote :

There's something weird going on here: is not true that fedora did the same!
You can find in attachment the kernel config from FC14, which shows that OSS emulation in ALSA was not removed at all from the kernel in FC14.

Here is a side-by-side difference with ubuntu (limited to the relevant part):
Fedora config Ubuntu config
CONFIG_SOUND_OSS_CORE=y # CONFIG_SOUND_OSS_CORE is not set
CONFIG_SOUND_OSS_CORE_PRECLAIM=y <
CONFIG_SND=m CONFIG_SND=m
CONFIG_SND_TIMER=m CONFIG_SND_TIMER=m
CONFIG_SND_PCM=m CONFIG_SND_PCM=m
CONFIG_SND_HWDEP=m CONFIG_SND_HWDEP=m
CONFIG_SND_RAWMIDI=m CONFIG_SND_RAWMIDI=m
CONFIG_SND_JACK=y CONFIG_SND_JACK=y
CONFIG_SND_SEQUENCER=m CONFIG_SND_SEQUENCER=m
CONFIG_SND_SEQ_DUMMY=m CONFIG_SND_SEQ_DUMMY=m
CONFIG_SND_OSSEMUL=y |# CONFIG_SND_MIXER_OSS is not set
CONFIG_SND_MIXER_OSS=m |# CONFIG_SND_PCM_OSS is not set
CONFIG_SND_PCM_OSS=m |# CONFIG_SND_SEQUENCER_OSS is not set
CONFIG_SND_PCM_OSS_PLUGINS=y <
CONFIG_SND_SEQUENCER_OSS=y <

Moreover I agree with Fabien Lusseau: where ALSA OSS emulation has been so strongly deprecated is yet to be shown (where all the posts demonstrate on the opposite that is still useful in many use-cases).

To cleanup the audio landscape wouldn't it be enough to prevent it from loading by default? At least who wanted it back could just re-enable it...
And why the rush? Lucid had it enabled and maverick got mutilated, wouldn't it be wiser to project a smoother transition with some progressive dismiss steps?

Where it's a fact that the sudden OSS emulation removal has caused immediate problems to many users and applications, the long-term advantages are arguable and subject to personal evaluation.

Please reconsider the choice and reintegrate oss emulation in the kernel, maybe blacklist it's modules by default it if you are so strongly persuaded that it should be abandoned as soon as possible.

Hello,

Nice move Yota,

I do not have fedora so i could not see that. But the longer the more it seems to be a very big issue in ubuntu. perhaps fedora just blacklisted the oss emu by default settings but is it just easy to reenable it by removing them from blacklist or adding them to modprobe modules to load at boot time.

That's also the way it should be in ubuntu and is the linux philisophy. Also it's the reason why basic linux kernels still have oss into it. And on the contrary is NOT deprecated.

In despite off the extreme heavy job Mister T-Chen is performing. He forget's that linux and ubuntu is for a tremendous amount off hardware . From basic chipset up to Mb manyfactor Device manifiactor's and so on. He just test on his own version and think it should work for everybody which is not the case. Also with only his needed software.

But having NO reaction off him excpet NO !

Not any reasonable alternatifs. A forcing to an uncomplete pulse ???????

I hope the ubuntu kernel team will decide to enable it back again. So m

Sorry I continue here.

So many users will be able again to use ubuntu like it should be.

greetings christophe

pipegeek (pipegeek) wrote :

Yet another person who would really like to see this put back in, if only as modules that aren't loaded by default. padsp doesn't work for everything. Particularly it doesn't work for /dev/sequencer, so anything that is attempting to speak MIDI to the sound card via OSS is now left stranded. This change also broke the "oss-compat" package in universe. Would really, really like to see this change reverted.

Claudiu Vlad (claudiu-vlad) wrote :

I am not asking for changing kernel options, its not my job, but as an old
user, I really want this to be fixed some way or another.

Cheers,

On Thu, Nov 11, 2010 at 7:02 AM, pipegeek <email address hidden> wrote:

> Yet another person who would really like to see this put back in, if
> only as modules that aren't loaded by default. padsp doesn't work for
> everything. Particularly it doesn't work for /dev/sequencer, so
> anything that is attempting to speak MIDI to the sound card via OSS is
> now left stranded. This change also broke the "oss-compat" package in
> universe. Would really, really like to see this change reverted.
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

markofealing (mark-ferns16) wrote :

Anyone hoping to use Spotify under wine can think again, totally hosed unless you are a Spotify Premium user using the beta Linux client :-((. Otherwise Spotify recommend you use Wine. Little do they know is no longer works!

Many thanks to all the developers who could not care less about making sure existing applications will still work after they make "good idea changes". Shame on you all.

Total Fail!

Psychotron (redm) wrote :

Sorry Mr. Chen, but this is a totally ridiculous decision! Who is hurt by keeping these little modules?! Nobody! Does it break anything?! I wouldn't know what. Sorry if this is not very constructive, but this kind of decisions just make me angry. You just break it for a lot of people, without providing a proper alternative. And what for?!?

I just rebuilt my kernel and now alsa is somehow broken...yea, I have too much time at my hands to investigate such nonsense.

Mark Faine (mark-faine) wrote :

This broke mythtv 0.24 and tvtime for me ever since I upgraded to maverick. I don't mind modernizing but you simply don't remove functionality until you have something to replace it with. I have gone back to the 32 kernel for now since it is the last known working kernel.

David Henningsson (diwic) wrote :

Folks, I haven't been closely been involved with the decision to remove OSS from the kernel, and I see that it causes frustration to have functionality removed, but I know that it wouldn't have been done if it haven't helped against frustration at some other end. I believe Daniel T Chen has trying to explain some of that higher up in the thread here.

So for options for people bitten by this problem, here are the options as I see it:

1) Help out by moving programs and hardware from OSS to ALSA. File bugs. Retest PulseAudio, file bugs (with e g "ubuntu-bug audio") if things do not work as expected, help out with testing. This is the recommended and most constructive approach.

2) Stay with Lucid, an LTS release which will be supported for three years on the desktop. You can enable lucid-backports if you want later versions of some programs.

3) Build your own kernel. Note that it won't get updated via -security or -updates if you do that.

I also note that this change was done in May, and the first response comment in August - three months later! This means to me, that this issue either affect relatively few people, or that we lack testers of the development release.

Psychotron (redm) wrote :

I can't see any explanation in this thread on why this has to be done. Perhaps you can explain that to us ignorant folks. That programs should be moved to a newer API is not per se a bad thing, but rather the way this is done here. And really, I don't see the problem of providing the ALSA OSS emulation(!!) layer. All new apps can simply ignore it. So please where is the problem? And if older apps don't support modern audio features of say PA, so what? Better than not working at all in any case.

As for your suggested options:
1) How about _first_ doing this and then remove functionality. Further I doubt that this will ever happen, as some often used apps aren't really maintained anymore e.g. tvtime.
2) Unfortunately I for one have to use Maverick kernel, as with Lucid the radeon support is completely broken. And now that I did the update I surely have better things to do than downgrading to Lucid. And also I doubt that with the next LTS there is a proper replacement for say tvtime.
3) This is a pain and no solution! Hours of compiling for every security fix...

And when did Maverick hit the masses? Right, in Oktober! So you want to make users hit by this bug responsible for not using very early test releases?? Come on!

David Henningsson (diwic) wrote :

Ubuntu is depending on volunteers to do very, very much - very large parts of planning, development, bug fixing, testing, and documentation are made by volunteers, and would fall flat without them.

Also, this removal was being done at a time were it would be the least painful, in the beginning of a development cycle (so that there would be plenty of time of test and sort out the remaining issues), and right after a LTS release, so that people who need OSS still will have a functional Ubuntu version for three more years.

As for building your own kernel, we have some guides out there (under wiki.ubuntu.com/Kernel/Dev ) and I'm waiting for another guide that is hopefully going to be even better. My hope is that it will be possible to auto-build custom kernels in PPAs, so that an initial setup is all you need - but I don't know for sure.

So I'm not an expert on what the kernel OSS emulation is doing bad; but I'm assuming that it won't work with bluetooth or firewire audio, and that it grabs exclusive access (i e, it won't mix with other sources, but whoever grabs it first wins). There is also the slim-and-trim argument - Ubuntu must fit on a CD, have fast startup times, less security holes, etc (although again, I don't know if the extra space and time is negligible).

So can I get a summary of what applications that actually need this emulation? Can we port them to ALSA, or at least fix them so they work with the userspace emulation (aoss / padsp)? Perhaps your favourite app can work better than ever in Ubuntu 11.04?

James Andrewartha (trs80) wrote :

David: If you read the bug log, you'll see that ALSA OSS emulation was disabled because the plan was to have OSSp working for Maverick. This didn't happen, but ALSA OSS emulation remains disabled. OSSp is probably the correct solution for the future, but it's not here yet, so can we just have ALSA OSS emulation turned back on for Maverick?

Applications that need this emulation: Games using the quake3 engine, which are closed source and can't be changed.

Claudiu Vlad (claudiu-vlad) wrote :

1. tvtime
2. gnomeradio

everybody, feel free to continue my list

On Fri, Nov 19, 2010 at 5:44 PM, David Henningsson <
<email address hidden>> wrote:

>
> So can I get a summary of what applications that actually need this
> emulation? Can we port them to ALSA, or at least fix them so they work
> with the userspace emulation (aoss / padsp)? Perhaps your favourite app
> can work better than ever in Ubuntu 11.04?
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Claudiu Vlad (claudiu-vlad) wrote :

3. Applications that need this emulation: Games using the quake3 engine,
which are closed source and can't be changed. (thanks to James Andrewartha)

On Fri, Nov 19, 2010 at 6:23 PM, James Andrewartha <email address hidden> wrote:

> David: If you read the bug log, you'll see that ALSA OSS emulation was
> disabled because the plan was to have OSSp working for Maverick. This
> didn't happen, but ALSA OSS emulation remains disabled. OSSp is probably
> the correct solution for the future, but it's not here yet, so can we
> just have ALSA OSS emulation turned back on for Maverick?
>
> Applications that need this emulation: Games using the quake3 engine,
> which are closed source and can't be changed.
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Psychotron (redm) wrote :

So OSS doesn't support some advanced features? Sure. But why does that mean OSS support needs to be broken? If users of some OSS-only app want these features, they can bug the authors to add support for PA or whatever.

As for grabbing devices exclusively, I'm under the impression that it's possible for a long time to allow even OSS apps to access devices in parallel with ALSA. At least I haven't had problems with that for years now.

Space for these three modules is 124K on my system....

And really: in this particular case I don't understand the necessity of the removal. It's not that OSS is a system foundation and it's just too limited for the future. It's just an ADDON. You can safely ignore it if your apps all use ALSA. If you want to get it out of the main kernel, then at least provide it as a separate package, e.g. using DKMS.

Besides the fact, that aoss (and possibly padsp) does not really work, it's also much less comfortable. OSS emulation modules "just work", with aoss you have to find out about it first. Then find out what and how to change. Probably nothing the average user is able to.

And sure there are guides to compile a kernel. Still it's not exactly a 5min job. And when will this advanced kernel build system see the light of day? Nobody knows? That's not a great base for an alternative solution. And again: it takes hours! On every update! I don't want to imagine how log it takes on a netbook... And what for? For three tiny modules!

Also in my experience with Ubuntu it's unfortunately only partly possible to stick with an LTS release. There is just always a breakage wich is only fixed in the next release. In my example with Lucid the broken radeon driver. Also sometimes you just need a newer version of some software. E.g. the latest KDE is only supported for the last two Ubuntu releases or so. So you want to tell users: Sorry you can't upgrade to a newer desktop shell, if you want to keep the mixer of you TV app working?

So telling users to stick with LTS is only partly an option. Let alone that I don't have much faith everything will be fixed with say the next LTS.

The solution is pretty simple: readd the modules in some way or another! It hurts nobody (unless proved otherwise) and every other "solution" is just inferior.

PS: In my case the app is tvtime and what doesn't work is the mixer (i.e. adjusting volume).

Claudiu Vlad (claudiu-vlad) wrote :

SOLUTION: provide a PPA containing a custom OSS enabled kernel

How about that ?

On Fri, Nov 19, 2010 at 6:45 PM, Psychotron <email address hidden>wrote:

> So OSS doesn't support some advanced features? Sure. But why does that
> mean OSS support needs to be broken? If users of some OSS-only app want
> these features, they can bug the authors to add support for PA or
> whatever.
>
> As for grabbing devices exclusively, I'm under the impression that it's
> possible for a long time to allow even OSS apps to access devices in
> parallel with ALSA. At least I haven't had problems with that for years
> now.
>
> Space for these three modules is 124K on my system....
>
> And really: in this particular case I don't understand the necessity of
> the removal. It's not that OSS is a system foundation and it's just too
> limited for the future. It's just an ADDON. You can safely ignore it if
> your apps all use ALSA. If you want to get it out of the main kernel,
> then at least provide it as a separate package, e.g. using DKMS.
>
> Besides the fact, that aoss (and possibly padsp) does not really work,
> it's also much less comfortable. OSS emulation modules "just work", with
> aoss you have to find out about it first. Then find out what and how to
> change. Probably nothing the average user is able to.
>
> And sure there are guides to compile a kernel. Still it's not exactly a
> 5min job. And when will this advanced kernel build system see the light
> of day? Nobody knows? That's not a great base for an alternative
> solution. And again: it takes hours! On every update! I don't want to
> imagine how log it takes on a netbook... And what for? For three tiny
> modules!
>
> Also in my experience with Ubuntu it's unfortunately only partly
> possible to stick with an LTS release. There is just always a breakage
> wich is only fixed in the next release. In my example with Lucid the
> broken radeon driver. Also sometimes you just need a newer version of
> some software. E.g. the latest KDE is only supported for the last two
> Ubuntu releases or so. So you want to tell users: Sorry you can't
> upgrade to a newer desktop shell, if you want to keep the mixer of you
> TV app working?
>
> So telling users to stick with LTS is only partly an option. Let alone
> that I don't have much faith everything will be fixed with say the next
> LTS.
>
> The solution is pretty simple: readd the modules in some way or another!
> It hurts nobody (unless proved otherwise) and every other "solution" is
> just inferior.
>
> PS: In my case the app is tvtime and what doesn't work is the mixer
> (i.e. adjusting volume).
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Psychotron (redm) wrote :

> SOLUTION: provide a PPA containing a custom OSS enabled kernel

But then this kernel needs to be supplied with all the updates and fixes. I'd say a separate alsa-oss-modules package would be more realistic.

Claudiu Vlad (claudiu-vlad) wrote :

I personally dont care about updates, I have a family desktop, who the
hell can exploit it ?

On Fri, Nov 19, 2010 at 9:08 PM, Psychotron <email address hidden>wrote:

> > SOLUTION: provide a PPA containing a custom OSS enabled kernel
>
> But then this kernel needs to be supplied with all the updates and
> fixes. I'd say a separate alsa-oss-modules package would be more
> realistic.
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

yota (yota-opensystems) wrote :

Application affected:

4. MythTV (with analogue tv cards)

The above is a killer application, not only meaning that, quoting wikipedia, it is a "computer program that is so necessary or desirable that it proves the core value of some larger technology", but also meaning that made my wife a killer when it stopped working.

Maybe the alsa support for ALSA is present in v 0.24 as per http://www.mythtv.org/wiki/Release_Notes_-_0.24, I've not had the opportunity of testing it since v 0.23 is shipped with maverick. We could file bugs for every not working application but that's not the point since they are not, strictly speaking, broken!

The points are that:
1) ALSA OSS emulation removal caused many documented show-stopper issues
2) ALSA OSS emulation may be obsolete, but still is not deprecated in the kernel
3) ALSA OSS emulation removal can eventually bring arguable advantages (mutiopen?), which are yet to be proved, in an hypothetic future
4) ALSA OSS emulation could simply had been disabled by default, still no reason to ditch it so suddenly had been shown
5) ALSA OSS emulation seems to be still present in other mainstream distro

Disabling it by default would have been more than enough to strongly promote evolution, this harsh removal is overkill.
It just makes AboveAverage Joe downgrade or devolve his weekend spare time to study "custom kernel compiling for dummies".
Average Joe probably would end up saying "ubuntu just doesn't work".

One thing is encouraging progress, another is deliberately sabotage OSS to make people complain to application developers to switch to ALSA (applicable only where applications are open and mantained).

SOLUTION: re-enable it in the official kernel, blacklist its modules by default.

5. XawTV and all the tools for V4L (Video4Linux TV cards Drivers) that are bundled with. There if a solution for this entry, and it is to add XdTV (that is an updated version of XawTV) to the universe repository. But it will not append ... (The bug entry for package required is here for more than 3 years and no packages showed up)

> SOLUTION: re-enable it in the official kernel, blacklist its modules by default.

Yeah that's a good and simple idea, a dkms module or a module package can be really easier to end user.

And why not just re-enable it by default ? because this module can cause "troubles" only if we install some OSS only apps and we want to use it at the same time of another sound application ... And OSS only apps are very specific ... As I see, the only persons that are really touch be this problem is "Linux gamers" and "TV card Users"

Mike Hicks (hick0088) wrote :

I vote for restoring ALSA's OSS emulation module to the official kernel, and blacklisting it by default. If there was a separate package, I think it would inevitably get out of sync.

I am also dealing with this bug because of MythTV. Personally, I believe MythTV's 0.23's backend is broken in regards to audio _input_, though the frontend supports audio _output_ just fine when it's set up to use ALSA redirected through PulseAudio.

Like mythfrontend, it is often possible for ALSA programs to play nicely with PulseAudio. Most people should probably have an /etc/asound.conf file like this:

pcm.!default {
    type pulse
}
ctl.!default {
    type pulse
}

An ALSA program will read that file and realize it should redirect output through PulseAudio instead of talking to the hardware device directly. ALSA hardware devices (stuff in /dev/snd/*) can still be accessed directly if the programs are set up correctly and PulseAudio is deciding not to interfere. For instance, I can record audio with ALSA's "arecord" utility with "arecord -f dat -D hw:0,0 testfile.wav". I can also make arecord suck data through PulseAudio with "arecord -f dat -D default testfile.wav", and it works. Many people who have issues beyond that simply need to unmute their sound cards -- this can be accomplished by starting "alsamixer", pressing F6, selecting the appropriate hardware device, and changing the volume settings.

Unfortunately, some programs just don't work with ALSA, preferring to just operate with OSS-style devices. As I said, mythbackend seems to be one of those programs. I agree with yota that MythTV is a "killer app" for Linux and Ubuntu. If it doesn't work, it makes the entire platform unattractive to many people -- including myself, and I've been using Linux since 1996.

yota (yota-opensystems) wrote :

Why not a separate package (let's call it "ossemul-deprecate.dpkg"), shipped with the stock ubuntu, which contains just a file:

/etc/modprobe.d/blacklist-ossemul.conf

with "blacklist snd_pcm_oss" inside? (eventually add other oss emulation modules if opportune)

It would disable oss emulation by default, but still if, for any reason, one would like to get oss emulation back, he should just uninstall the above package (through CLI, GUI or anything) and would be up and running in a matter of seconds.
This would avoid any dkms compile complication or source misalignment, and it would require 0 manutention effort.

Also (desiderable, but not needed) packages known *not* to work without oss emulation could be marked conflicting with that package, such preserving usability during with the oss dismission plan.

Wouldn't anyone be happy in this way? If not could the maintainers please explain if (and why) such solution is not applicable?

markofealing (mark-ferns16) wrote :

6. Spotify under Wine - works but no audio, so essentially useless due to this major oversight.

It's a shame that they people at Spotify have gone through the trouble to assist Linux users in using their product http://www.spotify.com/uk/help/faq/wine/ only for the community to break it by making an uninformed decision on dropping OSS support!

Yota's idea of a separate package sounds like a good way forward, although not sure how non-technical Linux users are going to manage unless the installing of this package was somehow automated i.e. loaded when required.

David Henningsson (diwic) wrote :

I believe it is way too late to do these kind of configuration changes for Maverick, but if you really want to ask, here's the mailinglist: https://lists.ubuntu.com/mailman/listinfo/kernel-team
(It is probably not too late too ask for 11.04 - that said, I don't think they/we will enable it, but feel free to ask.)

@Mike, Ubuntu ships with such a file by default (or rather one that does that but only if PA is running), so there is no need to add such an /etc/asound.conf.

So, for closed source programs which we don't even ship in Ubuntu, such as Quake, we can't fix them, so it will be up to the closed source program vendor to adapt. At least if you ask me.
All the other programs here (tvtime, gnomeradio, mythtv and and xawtv), correct me if I'm wrong, are somehow related to capture cards, video and/or audio. Could it be the same sort of problem that affects them all?
MythTV has had some kind of ALSA support, even since 2004 (source - quick googling: http://www.gossamer-threads.com/lists/mythtv/users/89755 ).

So could you elaborate a little on the actual problem; are you having problem with a) audio input from the TV-card, b) audio output from the application and/or c) controlling the volume? And if it is controlling the volume, can you do that in alsamixer, outside the application? (I'm not saying it's practical, just trying to understand the problem.)

James Andrewartha (trs80) wrote :

"So, for closed source programs which we don't even ship in Ubuntu, such as Quake, we can't fix them, so it will be up to the closed source program vendor to adapt. At least if you ask me."

How about we ask Linus, who is totally against breaking the Linux ABI, as has been done here? You could fix them simply by reverting this change until OSSp works.

David Henningsson (diwic) wrote :

Ok, I'll answer my own question - I remembered I had an old TV card here somewhere, so I found it, plugged it in, installed tvtime and had a look. PCM Audio is working out of the box. ALSA mixer can control the TV card's input volume, but you can't control the ALSA mixer from tvtime (trying to change the volume has no effect), so that seems to be the issue.

Is that your issue as well?

Ole Laursen (olau) wrote :

David: That's exactly my problem (you can find more people with the same by looking through the bug reports linked to in one of the comments). I think Fedora has a patch for having tvtime use ALSA for volume control, see the link I provided. If you can package that up, I would personally be happy. But I think you're going to get busy. :)

In any case, OSS emulation has to land again at some point. You can't just expect vendors to adapt - many of the things people have trouble with aren't maintained anymore.

Psychotron (redm) wrote :

For tvtime at least there is a working ALSA mixer patch floating around. See also https://bugs.launchpad.net/ubuntu/+source/alsa-driver/+bug/613809.

But generally I agree with Ole. This attitude by the Ubuntu devs is just strange, it won't exactly create sympathy... Because of this and other things, I really consider switching to a different distribution.

yota (yota-opensystems) wrote :

@David Henningsson:

under the release notes of MythTV 0.24 ( http://www.mythtv.org/wiki/Release_Notes_-_0.24 )
you can read:

   Bug Fixes
   Fix ALSA mixer to open correct device when multiple devices are present [24864]
   Fix potential issue with multi-channel ordering when seeking/pausing if using OSS [25878] <- LOOK: ACTIVE OSS DEVELOPMENT IN 2010!!! THIS IS MADNESS! ;-)
   Fix support for snd-bt87x via ALSA [26261] <- ***THIS ONE***
   Many additional bugs fixed as part of the audio refactor/re-write mentioned below

My tv card is a BT878 (I believe nearly 50% of tv cards in my country have a BT87X). The problem is that you can't get audio recorded from the device on mythtv 0.23 without OSS emul.
And let me politely add that saying that "MythTV has had some kind of ALSA support" doesn't imply that it works, right?
Even if MythTV gets fixed what if I would like to play Unreal Tournament 2004? Probably no sound there too, and no developer to ask for a patch.

But again we are speaking about applications where a really simple solution exists elsewhere.
Removing OSS broke everything that was relying on it... quite simple, isn't it?
Probably we can't possibly enumerate here or be aware of every single application in the wild that is using it, but the number of posts in this bug report should state that problems about this removal are real, not limited to a specific application, not related to user mistakes and mostly unrecoverable without complex operations.

To reintroduce the feature in 11.04 doesn't cure the fact the issue is here now, and surely there are lots of users that don't bother to write bug reports that are experiencing that "audio just doesn't work".

I can understand that changes to kernel config can't be made lightly so before actually asking anything specific I was tryng to investigate if it can be agreed that a separate blacklist package would be a satisfying solution for everyone.

Still it bugs me a bit that no compelling reason to burn the bridges and prevent an OSS de-blacklist fallback was shown...

p.s. please pardon my jokes and a bit of, I hope constructive, polemic

David Henningsson (diwic) wrote :

@Ole, thanks for the tip. Here you are: https://launchpad.net/~diwic/+archive/maverick
Hope it builds fine, give it a try and tell me if it works.

@Psychotron, to see things from the other side: This is exaggerated, but somewhat true: http://yokozar.org/blog/content/linuxaudio.png - now imagine trying to find where a bug is, in an audio infrastructure that have looked somewhat like that - trying to remove an arrow every now and then is a good thing. As I said, it's causing frustration in one end, but it's reducing frustration in another end. And if this frustration can be solved by porting a few apps to ALSA, it might be worth it.

Psychotron (redm) wrote :

@David: I fully agree with this. But again: The problem is not THAT OSS support gets deprecated, but HOW. As discussed in this thread, there are or would have been _relatively_simple_ options to solve that more gently, without pissing off users too much. However, the message that comes across is: We have this plan and stick to it no matter what and what _you_ want we don't care. That's what I meant with "attitude". Even before the release of Maverick, when the first complaints appeared, when there would have been the chance to find a solution that serves all, the responsible persons didn't really care!

Claudiu Vlad (claudiu-vlad) wrote :

Good job, David ! It works ok now. Could you make it to go on alsa by
default ? I had to modify the xml file to change the mixer.

You made my day !

Lets see what are they going to do with the Quake based games ...

On Mon, Nov 22, 2010 at 6:04 PM, David Henningsson <
<email address hidden>> wrote:

> @Ole, thanks for the tip. Here you are:
> https://launchpad.net/~diwic/+archive/maverick<https://launchpad.net/%7Ediwic/+archive/maverick>
> Hope it builds fine, give it a try and tell me if it works.
>
> @Psychotron, to see things from the other side: This is exaggerated, but
> somewhat true: http://yokozar.org/blog/content/linuxaudio.png - now
> imagine trying to find where a bug is, in an audio infrastructure that
> have looked somewhat like that - trying to remove an arrow every now and
> then is a good thing. As I said, it's causing frustration in one end,
> but it's reducing frustration in another end. And if this frustration
> can be solved by porting a few apps to ALSA, it might be worth it.
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Mike Thomas (rmthomas) wrote :

@David Henningsson:

My naive interpretation of diagram

http://yokozar.org/blog/content/linuxaudio.png

is

(1) OSS offers the most direct route (2 steps) between a userspace program and the output hardware, and therefore would be expected, a priori, to provide the best latency. Audio-video applications (in contrast to purely audio applications) demand low latency as the primary requirement for the sound system.

(2) The complexity arises from a trend towards virtualization, which introduces software layers not needed by most users, introduces latency and loads the CPU. It is ironic that removal of OSS is seen as a solution.

More generally: you say "porting a few apps to ALSA" might be "worth it". I would have sympathy for this point of view if you were offering to do the porting yourself. It should be remembered that "filing a bug report" against a working application is a euphemism for asking somebody else to do some unnecessary work.

Mike

Ole Laursen (olau) wrote :

@David: works for me too, when I change the MixerDevice setting to "hw:0" (or in my case "hw:Audigy") as indicated in the Fedora bug (just wasted an hour finding out that "default" doesn't work, googling impenetrable shoddy ALSA documentation, no wonder it has been so long in replacing anything, the API is total crap). Thanks for working on this!

To those who're still in the mud: try the kernel team! I've already emailed ubuntu-devel, maybe that's how David found us! I wouldn't bother contacting Leann Ogasawara, I've tried that twice with no reply. Maybe she's busy breaking other apps that used to work. :)

David Henningsson (diwic) wrote :

@Ole, added bug #680386 for the tvtime update. After it has been accepted into Natty, we can request an stable release update to Maverick, I saw Daniel suggested that in ubuntu-devel.

@Mike, the diagram is not good enough to make that conclusion. Also, what we're removing is one of several arrows from OSS to ALSA, as we're removing ALSA's OSS emulation, not OSS itself.

@yota, that's good news! Seems like we should make sure 0.24 gets packaged for Natty. The 0.24 diff is too big to do as a stable update for Maverick, but perhaps it can be released in a PPA or through ubuntu-backports.

Joe User (axyz-yahoo) wrote :

I also request that this bug be fixed, and the kernel expose the /dev/mixer, /dev/dsp, and other devices..

I have 3 sound cards in my home machine, hooked up to several radio tuners.

Signals are recorded according to cron jobs and bash scripts.

How exactly will I replace that functionality with PulseAudio?

I reiterate the opinion above that PA is garbage. A particulary smelly, slimy load of garbage.

Please make PA coexist with the legacy means of sound card control.

Is this change infecting other distributions? Can I use Debian to avoid this problem? Advice about other distributions would be helpful.

Thank you.

yota (yota-opensystems) wrote :

@Joe User:
Debian seems ok (I've just tested Sid with 2.6.32 kernel, and snd_pcm_oss module is available).

Probably the only distributions affected by this bug (or should I say "affected by this fix"?) are ubuntu and derivatives, I can confirm the issue on mint 10.

@David:
Yes, having a working mythTV in natty would be a good new indeed, having it working out of the box in maverick would have been even better. Please note that mythTV ALSA support would have been fixed even without OSS sabotage.

Also the way you carefully ignored other parts of my verbose post make me suspect that the message Psychotron read between the lines is correct.
Still I strongly believe that if someone, who participated to the decision that this* was the best way to go, care to share it would be easier for everyone to understand the unquestionable choice of ditching OSS.

*for the sake of clarity: let me repeat once more that with "this" i refer to the decision to totally remove OSS instead of blacklist it, and not about the opportunity to dismiss OSS or not.

Mike Thomas (rmthomas) wrote :

When I first saw "Bug" #579300 in early September I was puzzled, because it seemed to make no sense at all. Things are clearer now.

(1) People who have been using applications dependent on OSS are no longer welcome on Ubuntu and must go elsewhere. Mr Chen was given the thankless task of making this known. I'm not critical of him - he thinks he is doing the right thing.

(2) Since there is no plausible technical reason for disabling OSS, we must look elsewhere for the explanation. No doubt this lies in the sociology of open-source audio development and/or in the business model for eventual monetization of Ubuntu. I personally am not sufficiently interested to speculate about this.

(3) I would like to think that Debian is the answer, but the very lengthy wait for the release of Squeeze leads me to suspect that there are serious problems (of a different kind) with Debian too.

(4) The way that the killing of OSS has been handled in Ubuntu is ugly, but I see it as merely part of a wider malaise, just one more nail in the coffin of Linux multimedia. Of course, Linux will survive in the long term - on servers.

Mike

David Henningsson (diwic) wrote :

@yota, I'm not sure what you believe I ignored, but I don't have the time/priority to answer all of you thoroughly.
So for the compile-but-blacklist option, if that was what you thought I ignored, here's my personal opinion:
 Maverick: doing configuration changes for the Maverick kernel is way too late, so no use discussing it.
 Natty: Out of the applications listed here so far that Ubuntu ships, AFAIK tvtime and mythtv already have fixes (gnomeradio as well? I'm not sure), so I'm very hopeful that we'll have a better situation for Natty for the last few applications still requiring the kernel-space emulation. Since I don't care about Quake and other stuff we don't ship, I think it's unnecessary to enable compile-but-blacklist.

@Mike, I have assisted in making the fixed tvtime available so yes, I'm prepared to do some of the work.

Claudiu Vlad (claudiu-vlad) wrote :

@David, I saw a problem with patched tvtime, sometimes when cpu is
overloaded with different applications and tvtime is minimized, I restore
tvtime window but its black (although sound is playing ok continuously), and
stays black until restarting the computer.
So maybe someone could check this thing. Thanks a lot.

On Thu, Nov 25, 2010 at 12:59 AM, David Henningsson <
<email address hidden>> wrote:

> @yota, I'm not sure what you believe I ignored, but I don't have the
> time/priority to answer all of you thoroughly.
> So for the compile-but-blacklist option, if that was what you thought I
> ignored, here's my personal opinion:
> Maverick: doing configuration changes for the Maverick kernel is way too
> late, so no use discussing it.
> Natty: Out of the applications listed here so far that Ubuntu ships, AFAIK
> tvtime and mythtv already have fixes (gnomeradio as well? I'm not sure), so
> I'm very hopeful that we'll have a better situation for Natty for the last
> few applications still requiring the kernel-space emulation. Since I don't
> care about Quake and other stuff we don't ship, I think it's unnecessary to
> enable compile-but-blacklist.
>
> @Mike, I have assisted in making the fixed tvtime available so yes, I'm
> prepared to do some of the work.
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

David Henningsson (diwic) wrote :

@Claudiu, this sounds unrelated to my patch (although you can never know for certain), so please file a separate bug against tvtime (this is ok as the patched tvtime version is already in Natty).

yota (yota-opensystems) wrote :

@David:
Even if our opinions are hugely different I really thank you for your answer.
Indeed my primary (but not only) concern was about include-but-blacklist oss emul, which was originally proposed by other users (Christophe Van Reusel, what_if) since 2010-10-22, and which still seems a viable solution for everyone, but lacked any kind of official reply until now.
I don't agree with your conclusion but I can see your points.

This said I hope it's fine if I continue exposing some of my thoughts about this "fix", feel free to skip the remaining part according to your priorities.

Even if for OSS is "Too late, always was, always will be", I hope that at least the way in which this removal was handled can be reconsidered.

I don't see why ubuntu should be hostile (or simply ignore) to applications not shipped with it, and if the devs don't care about Quake, UT, Enemy Territory (just to pick some titles from above) does not mean others feel the same. No one is asking to support those applications, but just not to actively work against them. Is ubuntu going to become a walled-market os where installing anything outside the repo is impossible? Are phone capability planned at least? ;-)

Every piece of software can be a valuable asset and deliver value to both to users and to the platform itself.
Moreover I'm not an audio expert but it comes to mind also that OSS is portable while ALSA is linux only, and so this choice damages various BSD flavours and fragment the opensource sound landscape.

It's a wide accepted principle that API should get deprecated before being removed, this has not happened here.
This is an howto (with the purpose of using OSS on ubuntu) which is just an year old https://help.ubuntu.com/community/OpenSound where is said that "OSS 4.x is alive and well". If you google "ubuntu oss remove" no official discussion shows up, no warning whatsoever. The fact that this very thread comes up as the 5th result demonstrate how scarce are public discussion about the opportunity of removing OSS support (if someone spoke about this plan in a private masonic lodge doesn't count).

I hope no investor willing to spend money on linux software development read this, because I'm sure that the "a not deprecated API can be dropped everyday without any warning or reason" message is not so reassuring.

Since my focus is not on audio I'll made an act of thrust and try to accept this choice. I hope that time will show me that this makes more sense than it seems. What I'm sure is that things could have been handled better.

If you made this far despite the "escape clause" above, thank you for your time.

Rechner-Tester (cs-rechner) wrote :

As yota (ironical) wrote in comment #89:

> Fix potential issue with multi-channel ordering when seeking/pausing if using OSS [25878] <- LOOK: ACTIVE OSS DEVELOPMENT IN 2010!!! THIS IS MADNESS! ;-)

...and clarified in comment #102:
>Moreover I'm not an audio expert but it comes to mind also that OSS is portable while ALSA is linux only, and so this choice damages various BSD flavours and fragment the opensource sound landscape.

ALSA is Linux only, while OSS - shabby as it may be compared to ALSA - is much more portable (http://en.wikipedia.org/wiki/Open_Sound_System says OSS is available on "11 major Unix-like operating systems").
So maybe we don't need OSS, but we (optional) need the ALSA OSS-emulation.
  - To not break the whole *nix Sound landscape in to a Linux and a Unix part
  - To not break many applications and games
  - To not harm the end user experience
  - To not be offensive to application/game developers which want to develop multi platform programs

Blacklisting sounds like a compromise for me. But how does removing with no or only short-term announcing fits to the ubuntu
philosophy to be "people's allegiances and relations with each other" (https://help.ubuntu.com/10.10/about-ubuntu/C/about-ubuntu-name.html)? In my opinion it's offensive to users and developers.

Don't get me wrong: I'm sure there are reasons to drop OSS Support but please do it a long-term way to give developers and users the chance to prepare.
Compiling but blacklisting dosn't harm anybody or anything, but gives an option for an easy workaround while still bringing the plans to drop OSS support into focus.

regards

Rechner-Tester

starsss (starsss) on 2010-12-11
summary: - Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
+ Пожалуйста, отключите * CONFIG_SOUND_OSS и OSS CONFIG_SND_ * *

Creating problems for simple end users in the name of "user experience"!! Remove functionality before equally-good-or-better alternatives are available! Simply ridiculous!

B*lls to control freak idiots - if I use an app that is old and no longer under active development, it simply means that I like it and am comfortable with it. Don't give me lectures on "standard user experience" and the need to move forward. Crippling functionality of what I already had and invested time and effort in configuring to my liking!

F**k you Steve J*bs!! Creating usability issues for people dumb enough to use your products, nice way to treat them!!

.... OH WAIT! This 'fix' did not come from A$$le, did it!!
Could not notice the difference - please replace Meerkat/Daniel T Chen/Any-other-self-proclaimed-crusader-for-coding-practice-above-"normal"-end-user-comfort for Steve up there.

Time to move on?

summary: - Пожалуйста, отключите * CONFIG_SOUND_OSS и OSS CONFIG_SND_ * *
+ Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
Simos Xenitellis  (simosx) wrote :

When you try to compile Alsa on Ubuntu 10.10, it compiles fine. When you try to load the new kernel modules, you get

[ 332.243113] snd: Unknown symbol unregister_sound_special (err 0)
[ 332.243379] snd: Unknown symbol register_sound_special_device (err 0)
[ 332.245467] snd_timer: Unknown symbol snd_info_register (err 0)
[ 332.245631] snd_timer: Unknown symbol snd_info_create_module_entry (err 0)
[ 332.245839] snd_timer: Unknown symbol snd_info_free_entry (err 0)
[ 332.246210] snd_timer: Unknown symbol __snd_printk (err 0)
[ 332.246373] snd_timer: Unknown symbol snd_iprintf (err 0)
[ 332.246607] snd_timer: Unknown symbol snd_ecards_limit (err 0)
[ 332.246834] snd_timer: Unknown symbol snd_oss_info_register (err 0)
[ 332.246997] snd_timer: Unknown symbol snd_unregister_device (err 0)
[ 332.247224] snd_timer: Unknown symbol snd_device_new (err 0)
[ 332.247625] snd_timer: Unknown symbol snd_register_device_for_dev (err 0)

As far as I understand, this is related to the rest of the kernel being compiled with the Alsa OSS sound options.
I am actually fine with this decision of removing OSS. OSS was deprecated for ages.

However, what changes do I need to make to the stock Alsa so that it can be used in Ubuntu 10.10 (or newer)?

markofealing (mark-ferns16) wrote :

Regarding my problem with no audio when running Spotify under Wine since upgrading to Ubuntu 10.10. This is fixed by upgrading Wine to 1.3.9 Beta from the stock 1.2 which ships with Ubuntu 10.10. see my blog for more details http://mylinuxramblings.wordpress.com/know-linux-bugs/

Simos

When you try to compile Alsa on Ubuntu 10.10, it compiles fine. When you try to load the new kernel modules, you get
....

As far as I understand, this is related to the rest of the kernel being compiled with the Alsa OSS sound options.
I am actually fine with this decision of removing OSS. OSS was deprecated for ages.

Hello,

Sorry I don't know how to do for stock alsa. But as far as I understand here your problem is maybe just related because oss is removed .... The 10.10 kernel is NOW COMPILED WHITHOUT OSS. And this is THE PROBLEM A LOT OF OTHER USERS HAVE..

For Your problem just google around and i'm shure you'll find it somewhere. It's possible that you have to use a patch somewhere before you compile.

soreau (oreaus) wrote :

I found this link thanks to kklimonda on freenode. http://nullkey.ath.cx/~stuff/et-sdl-sound/ Make sure to change the SDL_AUDIODRIVER to pulse.

Cheers.

Simos Xenitellis  (simosx) wrote :

Regarding the compilation of the latest Alsa for Ubuntu 10.10 (or newer), when you run

./configure

You need to add the option --with-oss=no, as in

./configure --with-oss=no

and you are set.

@David: Cool, thanks a LOT.

On Fri, Nov 26, 2010 at 8:28 AM, David Henningsson <
<email address hidden>> wrote:

> @Claudiu, this sounds unrelated to my patch (although you can never know
> for certain), so please file a separate bug against tvtime (this is ok
> as the patched tvtime version is already in Natty).
>
> --
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
> https://bugs.launchpad.net/bugs/579300
> You received this bug notification because you are a direct subscriber
> of the bug.
>

martinwguy (martinwguy) wrote :

Hi all
   Here's the latest maverick linux kernel compiled for x86, with the OSS compat stuff re-enabled.

      M

martinwguy (martinwguy) wrote :

...and the corresponding linux-headers package...

@martinwguy:
first of all, thanks so much for making this deb
but I experienced a couple of problems trying to use your 2.6.35.8+oss kernel:
- I get a long list of errors (can't cut and paste from the Gdebi console) when installing both the image and the headers from deb
- after installing the headers Gdebi lists an error which says I need to install the headers (?!)
- the broadcom driver doesn't work in this kernel so I'm not able to get wifi
here is the broadcom driver url:
http://www.broadcom.com/support/802.11/linux_sta.php
 - I've found that 'Linux 2.6.35-24-generic' kernel works with the broadcom driver
- the Grub menu won't load by holding down the <shift> key during boot
that's all I found so far
has anyone else tried to install the 2.6.35.8+oss image and headers?
if so, any troubles/issues?

'Ubuntu needs to help consolidate, not help fragment, the audio landscape. As long as this emulation support remains enabled, we will remain in a quagmire of applications experiencing contention for the audio device, which increases the friction for adoption of Free Software.'

q: does this mean that the goal of Ubuntu is to divide pro and consumer audio into:

- enthusiasts = ALSA+Jack
&&
- cafe laptoppers = PulseAudio

?

martinwguy (martinwguy) wrote :

On Mon, Jan 3, 2011 at 10:27 PM, Kim Cascone <email address hidden> wrote:
So good to hear you! I love Blue Cube since the late 1980s :D and
published it with a load of other Csound pieces from that period.
freaknet.org/martin/audio/csound

Bless

    M

martinwguy (martinwguy) wrote :

On Mon, Jan 3, 2011 at 9:27 PM, Kim Cascone <email address hidden> wrote:
> but I experienced a couple of problems trying to use your 2.6.35.8+oss kernel:
> - I get a long list of errors (can't cut and paste from the Gdebi console) when installing both the image and the headers from deb
> - after installing the headers Gdebi lists an error which says I need to install the headers (?!)

I've tried thiss on mine, an Intel Celeron x86 laptop

> - the broadcom driver doesn't work in this kernel so I'm not able to get wifi
> here is the broadcom driver url:
> http://www.broadcom.com/support/802.11/linux_sta.php

Don't have an STA wifi setup, but already it sounds like you have
other problems. Possible that it is barfing at the '+' in the version
string? I can try setting off another build with a more conventional
name...

> - the Grub menu won't load by holding down the <shift> key during boot
> that's all I found so far

I've tried this too and it still works. However, the grub config will
have been rewritten during the kernel installation. Is it possible
that you are getting disk write or read failures?
Boot from a Live CD and run, as root, e2fsck -c /dev/sda1 (or
whichever disk is /)

> has anyone else tried to install the 2.6.35.8+oss image and headers?
> if so, any troubles/issues?

So far, no probs encountered here. Let me know about the disk integrity test.
... or re-install the packages to force rewriting of the grub files.
However, it shouldn't have touched anything to do with gdebi.

    M

martinwguy (martinwguy) wrote :

On Tue, Jan 4, 2011 at 2:05 AM, Martin Guy <email address hidden> wrote:
> On Mon, Jan 3, 2011 at 9:27 PM, Kim Cascone <email address hidden> wrote:
>> - I get a long list of errors (can't cut and paste from the Gdebi console) when installing both the image and the headers from deb
>> - after installing the headers Gdebi lists an error which says I need to install the headers (?!)
>
> I've tried thiss on mine, an Intel Celeron x86 laptop

Sorry, I meant to write: "...and it works fine for me."

>
>> - the broadcom driver doesn't work in this kernel so I'm not able to get wifi
>> here is the broadcom driver url:
>> http://www.broadcom.com/support/802.11/linux_sta.php
>
> Don't have an STA wifi setup, but already it sounds like you have
> other problems. Possible that it is barfing at the '+' in the version
> string? I can try setting off another build with a more conventional
> name...
>
>> - the Grub menu won't load by holding down the <shift> key during boot
>> that's all I found so far
>
> I've tried this too and it still works. However, the grub config will
> have been rewritten during the kernel installation. Is it possible
> that you are getting disk write or read failures?
> Boot from a Live CD and run, as root, e2fsck -c /dev/sda1 (or
> whichever disk is /)
>
>> has anyone else tried to install the 2.6.35.8+oss image and headers?
>> if so, any troubles/issues?
>
> So far, no probs encountered here. Let me know about the disk integrity test.
> ... or re-install the packages to force rewriting of the grub files.
> However, it shouldn't have touched anything to do with gdebi.
>
>    M
>

@martin: thanks for the kudos on 'blueCube( )' :)

as for the kernel build: I've automagically gotten pd to talk to the USB audio and the Intel HDA hardware without having to use Jack...not sure how I did this but it seems that my 'problem' is solved -- not that using Jack is a problem but you'd think plugging in a USB audio card should just work without being forced to use Jack...

thanks again for your response and help!

-~-
kim

Jeremy Foshee (jeremyfoshee) wrote :

changed assignee to David so that he can keep track of it.

~JFo

Changed in linux (Ubuntu):
assignee: Leann Ogasawara (leannogasawara) → David Henningsson (diwic)
martinwguy (martinwguy) wrote :

> 2) Since there is no plausible technical reason for disabling OSS, we must look elsewhere for the explanation.

This kind of thing, "deprecating" usually serves a psychological need of developers/managers, as a way of trying to eliminate something they see as evil, for whatever strange reason. We've seen it in GCC, breaking existing code, and (amazingly!) the newer ARM instruction sets.

It serves no purpose for the users of Ubuntu, having no effect whatever, except that of breaking half the software.

You remember how, in Toy Story 2, the penguin's voice box was broken? I saw it as a wry comment on Linux-based systems (on which the film was rendered) and how the audio support has been so flaky in the past. This decision renews that tradition... just when you thought audio had started working...

David Henningsson (diwic) wrote :

Reason for changing status: The intial request for change is performed. The rest of the thread is about the regressions that it caused.

Changed in linux (Ubuntu):
assignee: David Henningsson (diwic) → nobody
status: Fix Committed → Fix Released
martinwguy (martinwguy) wrote :

On 10 January 2011 22:10, David Henningsson <email address hidden> wrote:
> Reason for changing status: The intial request for change is performed. The rest of the thread is about the regressions that it caused.

Sorry, what has changed? Is OSS compat to be restored?

   M

Claudiu Vlad (claudiu-vlad) wrote :

@martin

check the thread title please !

On Tue, Jan 11, 2011 at 6:12 AM, martinwguy <email address hidden> wrote:

> On 10 January 2011 22:10, David Henningsson <email address hidden>
> wrote:
> > Reason for changing status: The intial request for change is performed.
> The rest of the thread is about the regressions that it caused.
>
> Sorry, what has changed? Is OSS compat to be restored?
>
> M
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/579300
>
> Title:
> Please disable CONFIG_SOUND_OSS* and CONFIG_SND_*OSS*
>

AJenbo (ajenbo) wrote :

1: I don't see why OSS had to be disabled for the distro so that some developers could investigate OSSp, why not just disable it them self in a test kernel. Unless they wanted some users reactions, possibly to identify affected software, and maybe drive some of them to update there sound method.

2: Where can we follow the progress of getting OSSp in to Ubuntu? Is there any way to help with that?

greg (grigorig) wrote :

I don't understand the rationale for this change. It is obvious that many people and a lot of software rely on OSS. The logical route to go about this would be to develop an OSS wrapper first (OSSp or whatever), and after it works to some degree, replace the OSS kernel stuff with it. Doing it the other way around is just asking for trouble.

What's wrong with blacklisting the OSS modules, but still shipping them with the kernel? So people who need OSS can enable it with minimal effort, while it's still disabled by default.

James Andrewartha (trs80) wrote :

I filed bug #716814 to revert this change, however they want verification it's still broken in the latest daily builds. I won't be able to do this for a week or so, but if someone else wants to test it earlier we can get it fixed sooner.

John Peach (john-launchpad) wrote :

Are we getting OSS emulation back in the kernel or do I need to change distros?

Rich3077 (rich3077) wrote :

I am a end user, not especially skilled in linux.
After much frustration I have found that this is the reason Ubuntu is not working for me.

I have found a pre compiled kernal to try and will probably give it a shot... or move to another distro.

As an end user I always thought linux was supposed to support older hardware/software? If everything was new would someone not just use Windows 7? In my case most everything is new but thats not good enough. I would understand and expect for linux to not support my ATI 3D cards in crossfire mode.. but it did... nice surprise. Now only if the sound would work.

I have yet to see an improvement from the last time I used Ubuntu several years ago... its still not ready to migrate Windows users and seems to be going backward from that goal as at least the last time everything worked.

I lost my Windows install as well as my legal valid product key for Win 7 so I am stuck with linux for a short time. (raid array gone wrong) Its just no fun anymore.

Simos Xenitellis  (simosx) wrote :

@Rich3077: When you compile your Alsa (alsa-driver), use the command line

./configure --with-oss=no

and that's it. It will now work.

You mention "Now only if the sound would work." You have a generic sound issue? This bug report affects only legacy (very old) apps that need OSS emulation to work.
If you have a generic sound problem, then there are ways to solve it (hint: run ubuntu-bug audio and follow the steps.).

Jacob Brown (jacob-gnu) wrote :

Hey guys!
I'm using natty and I've noticed that my old quake3 based games are still broken because you all decided to take out OSS compatibility. I tried to install OSSP, but that package doesn't even exist for Ubuntu. So, I did try to download and compile it manually, and after a while, I was able to get ossp to run, but it looks like it doesn't even support mmap for /dev/dsp, so I still can't play my old games.

You need to either re-enable OSS compatibility support (or at least put the snd-pcm-oss.ko into the oss-compat package which is currently broken), or fix OSSP so that it works with mmap programs and package it for Ubuntu so that non-developers can use it.

  I was telling my friend about it this weekend saying I was going to try to finally finish Return to Castle Wolfenstein, but that I couldn't get audio working on my computer. He was like, "Hahaha, Linux is always broken for games.", but I had to reply "This time, the Ubuntu developers actually broke it on purpose." :(

By the way, it is really bad manner to disable an important feature for your users just so you can try to develop some new replacement. You should have instead modified your own kernels on your dev-boxes instead of breaking it for the entire Ubuntu user base.

Thanks,
Jacob

yaztromo (tromo) wrote :

So I upgrade from 10.04 to 12.04 and find my SPU's (both petes and eternal) in PCSXR broken because of this. Since these pieces of software are no longer maintained how do you expect me file bugs with the developers Daniel? And, no, using pulseaudio is not an option since it has always refused to work with my USB soundcard.

Now I have to spend hours figuring out a hacky workaround for this "bug". You have to love progress...

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Related blueprints

Remote bug watches

Bug watches keep track of this bug in other bug trackers.